// this file is not used if use https://github.com/ant-design/babel-plugin-import
var ENV = process.env.NODE_ENV;

if (ENV !== 'production' && ENV !== 'test' && typeof console !== 'undefined' && console.warn && typeof window !== 'undefined') {
  // eslint:disable-next-line:no-console
  console.warn('You are using a whole package of ehome-rcm, ' + 'please use https://www.npmjs.com/package/babel-plugin-import to reduce app bundle size.');
}

export { default as Download } from './download';
export { default as SelectProject } from './select-project';
export { default as SelectOrganization } from './select-organization';
export { default as Loadable } from './loadable';
export { default as Helmet } from './helmet';
export { default as Blank } from './blank';
export { default as LottieAnimation } from './lottie-animation';
export { default as Spin } from './spin';
export { default as ResourceUnit } from './resource-unit';
export { default as Button } from './button';
export { default as PlateNumber } from './plate-number';
export { default as FileUpload } from './file-upload';
export { default as Toptip } from './toptip';
export { default as FormView } from './form-view';
export { default as RegionCode } from './region-code';